rm(list = ls())

#rpertoire
setwd("d:/temp/temp")

#chargement --> 99.06 sec.
system.time(D <- read.csv("kddcup99twice.txt",header=FALSE))

#type --> 'data.frame'
print(class(D))

#description
print(str(D))

#occupation mmoire --> 2130.2 MB
#gestionnaire de tches : 2259.6 Mo
print(object.size(D)/(1024*1024))

#restriction - 382696 - 0.44 sec.
system.time(print(nrow(D[D$V42=="normal." & D$V2=="udp",])))

#colonnes numriques
numeriques <- which(sapply(D,is.numeric))
print(numeriques)

#calculer les moyennes - 0.51 sec.
system.time(print(sapply(D[,numeriques],mean)))

#calculer les moyennes avec une restriction - 0.72 sec.
system.time(print(sapply(D[D$V42=="normal.",numeriques],mean)))

#trier selon la variable V34 - 3.23 sec.
system.time(print(head(D[order(D$V34),])))

#comptage de V42 - 0.20 sec.
system.time(print(table(D$V42)))

#moyenne de V34 selon V42 - 0.12 sec.
system.time(print(tapply(X=D$V34,INDEX=D$V42,mean)))

#moyenne de V34 selon (V42, V2) - 0.20 sec.
system.time(print(tapply(X=D$V34,INDEX=list(D$V42,D$V2),mean)))
            