rm(list = ls())

#rpertoire
setwd("d:/temp/temp")

#package - 1.12.0
library(data.table)

#chargement - 13.24 sec.
system.time(D <- data.table::fread("kddcup99twice.txt",header=FALSE))

#type --> "data.table" "data.frame"
print(class(D))

#description - 9796862 obs. of  42 variables
print(str(D))

#occupation mmoire - 2279.7 MB
#gestionnaire de tches : 2521.3 MB
print(object.size(D)/(1024*1024))

#restriction - 382696 - 0.12 sec.
system.time(print(D[V42=="normal." & D$V2=="udp",.(.N)]))

#colonnes numriques
numeriques <- which(sapply(D,is.numeric))
print(numeriques)

#calculer les moyennes - 0.51 sec.
system.time(print(D[,sapply(.SD,mean),,.SDcols=numeriques]))

#calculer les moyennes avec une restriction - 0.25 sec.
system.time(print(D[V42=="normal.",sapply(.SD,mean),,.SDcols=numeriques]))

#trier selon la variable V34 - 1.14 sec.
system.time(print(head(D[order(V34),])))

#comptage de V42 - 0.13 sec.
system.time(print(D[,.(.N),by=.(V42)]))

#moyenne de V34 selon V42 - 0.18 sec.
system.time(print(D[,.(mean(V34)),by=.(V42)]))

#moyenne de V34 selon (V42, V2) - 0.21 sec.
system.time(print(D[,.(mean(V34)),by=.(V42,V2)]))
            